package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.MyPageParam;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.constant.MongoConstant;
import com.yice.webadmin.app.dao.DatasetCleanConfigMapper;
import com.yice.webadmin.app.data.DatasetDataClean;
import com.yice.webadmin.app.data.DatasetDataDeduplicate;
import com.yice.webadmin.app.data.DatasetDataDesensitive;
import com.yice.webadmin.app.data.DatasetDataFilter;
import com.yice.webadmin.app.model.DatasetCleanConfig;
import com.yice.webadmin.app.service.DatasetCleanConfigService;
import lombok.extern.slf4j.Slf4j;
import org.bson.Document;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 数据集详情数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("datasetCleanConfigService")
public class DatasetCleanConfigServiceImpl extends BaseService<DatasetCleanConfig, Long> implements DatasetCleanConfigService {

    @Autowired
    private DatasetCleanConfigMapper datasetCleanConfigMapper;
    @Autowired
    private IdGeneratorWrapper idGenerator;
    @Autowired
    private MongoTemplate mongoTemplate;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<DatasetCleanConfig> mapper() {
        return datasetCleanConfigMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param datasetCleanConfig 新增对象。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public DatasetCleanConfig saveNew(DatasetCleanConfig datasetCleanConfig) {
        datasetCleanConfigMapper.insert(this.buildDefaultValue(datasetCleanConfig));
        return datasetCleanConfig;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param datasetCleanConfigList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<DatasetCleanConfig> datasetCleanConfigList) {
        if (CollUtil.isNotEmpty(datasetCleanConfigList)) {
            datasetCleanConfigList.forEach(this::buildDefaultValue);
            datasetCleanConfigMapper.insertList(datasetCleanConfigList);
        }
    }

    /**
     * 更新数据对象。
     *
     * @param datasetCleanConfig         更新的对象。
     * @param originaldatasetCleanConfig 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(DatasetCleanConfig datasetCleanConfig, DatasetCleanConfig originaldatasetCleanConfig) {
        MyModelUtil.fillCommonsForUpdate(datasetCleanConfig, originaldatasetCleanConfig);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<DatasetCleanConfig> uw = this.createUpdateQueryForNullValue(datasetCleanConfig, datasetCleanConfig.getCleanId());
        return datasetCleanConfigMapper.update(datasetCleanConfig, uw) == 1;
    }

    /**
     * 删除指定数据。
     *
     * @param cleanId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long cleanId) {
        return datasetCleanConfigMapper.deleteById(cleanId) == 1;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getdatasetCleanConfigListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<DatasetCleanConfig> getDatasetCleanConfigList(DatasetCleanConfig filter, String orderBy) {
        return datasetCleanConfigMapper.getDatasetCleanConfigList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getdatasetCleanConfigList)，以便获取更好的查询性能。
     *
     * @param filter  主表过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<DatasetCleanConfig> getDatasetCleanConfigListWithRelation(DatasetCleanConfig filter, String orderBy) {
        List<DatasetCleanConfig> resultList = datasetCleanConfigMapper.getDatasetCleanConfigList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    private DatasetCleanConfig buildDefaultValue(DatasetCleanConfig datasetCleanConfig) {
        if (datasetCleanConfig.getCleanConfigId() == null) {
            datasetCleanConfig.setCleanConfigId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(datasetCleanConfig);
        return datasetCleanConfig;
    }

    /**
     * 查询数据集清洗列表集合
     * @param filter 清洗标识
     * @param pageParam 页码参数
     * @return 返回查看对象列表
     */
    @Override
    public List<DatasetDataClean> getDatasetCleanList(DatasetDataClean filter, MyPageParam pageParam) {
        Query query = new Query(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()))
                .skip((pageParam.getPageNum() - 1) * pageParam.getPageSize())
                .limit(pageParam.getPageSize());

        return mongoTemplate.find(query, DatasetDataClean.class);
    }

    /**
     * 查询数据集过滤列表集合
     * @param filter 清洗标识
     * @param pageParam 页码参数
     * @return 返回查看对象列表
     */
    @Override
    public List<DatasetDataFilter> getDatasetFilterList(DatasetDataFilter filter, MyPageParam pageParam) {
        Query query = new Query(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()))
                .skip((pageParam.getPageNum() - 1) * pageParam.getPageSize())
                .limit(pageParam.getPageSize());

        return mongoTemplate.find(query, DatasetDataFilter.class);
    }

    /**
     * 查询数据集重复列表集合
     * @param filter 清洗对象
     * @param pageParam 页码参数
     * @return 返回查看对象列表
     */
    @Override
    public List<DatasetDataDeduplicate> getDatasetDeduplicateList(DatasetDataDeduplicate filter, MyPageParam pageParam) {
        Query query = new Query(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()))
                .skip((pageParam.getPageNum() - 1) * pageParam.getPageSize())
                .limit(pageParam.getPageSize());

        return mongoTemplate.find(query, DatasetDataDeduplicate.class);
    }

    /**
     * 查询数据集隐私列表集合
     * @param filter 清洗对象
     * @param pageParam 页码参数
     * @return 返回查看对象列表
     */
    @Override
    public List<DatasetDataDesensitive> getDatasetDesensitiveList(DatasetDataDesensitive filter, MyPageParam pageParam) {
        Query query = new Query(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()))
                .skip((pageParam.getPageNum() - 1) * pageParam.getPageSize())
                .limit(pageParam.getPageSize());

        return mongoTemplate.find(query, DatasetDataDesensitive.class);
    }

    /**
     * 查询数据集隐私总个数
     * @param filter 清洗对象
     * @return 返回查看对象列表
     */
    @Override
    public Long getDesensitiveCount(DatasetDataDesensitive filter) {
        Query query = new Query();
        query.addCriteria(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()));
        return mongoTemplate.count(query, DatasetDataDesensitive.class);
    }

    /**
     * 查询数据集清洗总个数
     * @param filter 清洗对象
     * @return 返回查看对象列表
     */
    @Override
    public Long getCleanCount(DatasetDataClean filter) {
        Query query = new Query();
        query.addCriteria(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()));
        return mongoTemplate.count(query, DatasetDataClean.class);
    }

    /**
     * 查询数据集过滤总个数
     * @param filter 清洗对象
     * @return 返回查看对象列表
     */
    @Override
    public Long getFilterCount(DatasetDataFilter filter) {
        Query query = new Query();
        query.addCriteria(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()));
        return mongoTemplate.count(query, DatasetDataFilter.class);
    }

    /**
     * 查询数据集重复总个数
     * @param filter 清洗对象
     * @return 返回查看对象列表
     */
    @Override
    public Long getDeduplicateCount(DatasetDataDeduplicate filter) {
        Query query = new Query();
        query.addCriteria(Criteria.where(MongoConstant.CLEAN_ID).is(filter.getCleanId()));
        return mongoTemplate.count(query, DatasetDataDeduplicate.class);
    }

    /**
     * 保存数据集清洗100条数据新增对象。
     *
     * @param cleans 新增对象。
     * @return 返回新增对象。
     */
    @Override
    public void saveDatasetClean(List<DatasetDataClean> cleans) {
        List<Document> documents = new ArrayList<>();
        if(CollUtil.isNotEmpty(cleans)) {
            for(DatasetDataClean dataClean : cleans) {
                Document document = new Document(MongoConstant.CLEAN_BEFORE_DATA, dataClean.getCleanBeforeData())
                        .append(MongoConstant.CLEAN_AFTER_DATA, dataClean.getCleanAfterData())
                        .append(MongoConstant.CLEAN_ID, dataClean.getCleanId())
                        .append(MongoConstant.CREATE_TIME, new Date());
                documents.add(document);
            }
            mongoTemplate.insert(documents, MongoConstant.DATASET_DATA_CLEAN);
        }
    }

    /**
     * 保存数据集过滤100条数据新增对象。
     *
     * @param filters 新增对象。
     * @return 返回新增对象。
     */
    @Override
    public void saveDatasetFilter(List<DatasetDataFilter> filters) {
        List<Document> documents = new ArrayList<>();
        if(CollUtil.isNotEmpty(filters)) {
            for(DatasetDataFilter filter : filters) {
                Document document = new Document(MongoConstant.CLEAN_BEFORE_DATA, filter.getCleanBeforeData())
                        .append(MongoConstant.CLEAN_AFTER_DATA, filter.getCleanAfterData())
                        .append(MongoConstant.CLEAN_ID, filter.getCleanId())
                        .append(MongoConstant.CREATE_TIME, new Date());
                documents.add(document);
            }
            mongoTemplate.insert(documents, MongoConstant.DATASET_DATA_FILTER);
        }
    }

    /**
     * 保存数据集去重100条数据新增对象。
     *
     * @param deduplicates 新增对象。
     * @return 返回新增对象。
     */
    @Override
    public void saveDatasetDeduplicate(List<DatasetDataDeduplicate> deduplicates) {
        List<Document> documents = new ArrayList<>();
        if(CollUtil.isNotEmpty(deduplicates)) {
            for(DatasetDataDeduplicate deduplicate : deduplicates) {
                Document document = new Document(MongoConstant.CLEAN_BEFORE_DATA, deduplicate.getCleanBeforeData())
                        .append(MongoConstant.CLEAN_AFTER_DATA, deduplicate.getCleanAfterData())
                        .append(MongoConstant.CLEAN_ID, deduplicate.getCleanId())
                        .append(MongoConstant.CREATE_TIME, new Date());
                documents.add(document);
            }
            mongoTemplate.insert(documents, MongoConstant.DATASET_DATA_DEDUPLICATE);
        }
    }

    /**
     * 保存数据集去隐私100条数据新增对象。
     *
     * @param desensitives 新增对象。
     * @return 返回新增对象。
     */
    @Override
    public void saveDatasetDesensitive(List<DatasetDataDesensitive> desensitives) {
        List<Document> documents = new ArrayList<>();
        if(CollUtil.isNotEmpty(desensitives)) {
            for(DatasetDataDesensitive desensitive : desensitives) {
                Document document = new Document(MongoConstant.CLEAN_BEFORE_DATA, desensitive.getCleanBeforeData())
                        .append(MongoConstant.CLEAN_AFTER_DATA, desensitive.getCleanAfterData())
                        .append(MongoConstant.CLEAN_ID, desensitive.getCleanId())
                        .append(MongoConstant.CREATE_TIME, new Date());
                documents.add(document);
            }
            mongoTemplate.insert(documents, MongoConstant.DATASET_DATA_DESENSITIVE);
        }
    }
}
